program Intenzita_Elektrostatickeho_Pole;

 uses crt, dos, graph;

 const Zoom = 1;
 const PosunX = 0;
 const PosunY = 0;
 const maxi = 20;

 const MaximalniPocetNaboju = 2;
 const e0 = 8.854e-12;

 var
  i          : INTEGER;
  Demo       : CHAR;
  gd, gm     : INTEGER;
  MAXX, MAXY : INTEGER;

  Krok   : REAL;

  er     : REAL;
  k      : REAL;

  Naboj  : array[0..MaximalniPocetNaboju] of record
    x, y : REAL;
    q    : REAL;
  end;

  PocetNaboju : INTEGER;


 function NactiNaboj : INTEGER;
  var Pokr : CHAR;
  begin
    Writeln;
    Writeln('Zadani naboje ', PocetNaboju);
    Write('x - pozice (m): ');
    Readln(Naboj[PocetNaboju].x);
    Write('y - pozice (m): ');
    Readln(Naboj[PocetNaboju].y);
    Write('naboj (C): ');
    Readln(Naboj[PocetNaboju].q);
    Write('Zadat dalsi naboj? (a/n): ');
    Readln(Pokr);

    if (Pokr = 'a') then NactiNaboj := 1
    else NactiNaboj := 0;
  end;

 procedure NactiUdaje;
  begin
    Write('Relativni permitivita dielekrika: ');
    Readln(er);

    PocetNaboju := 0;
    while (PocetNaboju < MaximalniPocetNaboju) AND (NactiNaboj <> 0) do PocetNaboju := PocetNaboju + 1;
    if (PocetNaboju < MaximalniPocetNaboju) then PocetNaboju := PocetNaboju + 1;

    Writeln;
    Write('Pocet kroku: ');
    Readln(Krok);
    if Krok <= 0 then Krok := 20;

    k := 1/(4*Pi*e0*er);
  end;

 procedure UdajeTest;
  begin
   PocetNaboju := 3;
   er := 1;
   k := 1/(4*Pi*e0*er);

   Naboj[0].x := 300;
   Naboj[0].y := 150;
   Naboj[0].q := 0.000003;

   Naboj[1].x := 300;
   Naboj[1].y := 300;
   Naboj[1].q := 0.000002;

   Naboj[2].x := 150;
   Naboj[2].y := 350;
   Naboj[2].q := -0.000006;

   Krok := 40;
  end;


 procedure Intenzita(x, y : REAL; var ix, iy : REAL);
  var i         : INTEGER;
      ex, ey, e : REAL;
      r, r2     : REAL;
      mx, my    : REAL;
  begin
    ex := 0;
    ey := 0;
    for i := 0 to PocetNaboju-1 do
    begin
      mx := x - Naboj[i].x;
      my := y - Naboj[i].y;
      r2 := mx*mx + my*my;
      r  := sqrt(r2);
      if r <> 0 then
      begin
        e := Naboj[i].q/r2;
        ex := ex + mx/r*e;
        ey := ey + my/r*e;
      end;
    end;
    ix := ex*k;
    iy := ey*k;
  end;

 procedure Kresli;
  var i       : INTEGER;
      x, y, k : REAL;
      xr, yr  : REAL;
      ix, iy  : REAL;
  begin
    k := MAXX/Krok;
    SetColor(15);

    x := 0;
    while x < MAXX do
    begin
      y := 0;
      while y < MAXY do
      begin
        xr := x*Zoom + PosunX;
        yr := y*Zoom + PosunY;
        Intenzita(xr, yr, ix, iy);
        ix := (ix - PosunX)/Zoom;
        iy := (iy - PosunY)/Zoom;
        if (abs(ix) < maxi) AND (abs(iy) < maxi) then begin
          Line(round(x), round(y), round(x + ix), round(y + iy));
          PutPixel(round(x), round(y), 12);
        end;

        y := y + k;
      end;
      x := x + k;
    end;

    SetColor(12);
    for i := 0 to PocetNaboju-1 do
    begin
      Circle(round(Naboj[i].x), round(Naboj[i].y), 5);
    end;

  end;



BEGIN

  clrscr;

  Write('Spustit demo? (a/n): ');
  Readln(Demo);
  if (Demo = 'a') then UdajeTest
  else NactiUdaje;

{
  for i:= 0 to PocetNaboju-1 do
  begin
    writeln(Naboj[i].x, ' - ', Naboj[i].y, ' - ', Naboj[i].q);
  end;
}

  gd := 0;
  gm := 0;
  initgraph(gd, gm, '');
  MAXX := GetMaxx;
  MAXY := GetMaxy;


  Kresli;

  repeat until keypressed;
  closegraph;


END.